#ifndef TYPES_H
#define TYPES_H


typedef double Value;
typedef int ID;
typedef int TheNumber;
typedef char* Name;
typedef int Logical;

#define NULLCHAR	'\000'

#define TRUE 1 
#define FALSE 0 
#define	True 1
#define False 0

typedef struct {
	char	optname[32] ;
	void	*vptr ;
	int		vsize ;
} option_t ;

#define	VV_INT		1
#define	VV_DOUBLE	2
#define	VV_BOOL		3
#define	VV_STRING	4
#define	VV_ONOFF	5
#define VV_NONE		6

#define SEE_NOTHING					0x00000000
#define SEE_SIDE					0x00000001
#define SEE_NUMBER					0x00000002
#define SEE_DISTANCE				0x00000004
#define SEE_ANGLE				    0x00000008
#define SEE_DISTANCE_CHANGE			0x00000010
#define SEE_ANGLE_CHANGE		    0x00000030
#define SEE_BODY_DIRECTION			0x00000040
#define SEE_NECK_DIRECTION			0x00000080
#define SEE_STAMINA     			0x00000100
#define SEE_EFFORT         			0x00000200
#define SEE_MASK					0x000003ff

#define EXPECTED_NOTHING            0x00000000
#define EXPECTED_SIDE				0x00000400
#define EXPECTED_NUMBER				0x00000800
#define EXPECTED_DISTANCE			0x00001000
#define EXPECTED_ANGLE				0x00002000
#define EXPECTED_DISTANCE_CHANGE	0x00004000
#define EXPECTED_ANGLE_CHANGE		0x00008000
#define EXPECTED_BODY_DIRECTION		0x00010000
#define EXPECTED_NECK_DIRECTION		0x00020000
#define EXPECTED_STAMINA 		    0x00040000
#define EXPECTED_EFFORT 		    0x00080000
#define EXPECTED_ACCELERATION       0x00100000
#define EXPECTED_ANGULAR_SPEED		0x00200000
#define EXPECTED_MASK               0x003ffc00

#define PREV_NOTHING                0x00000000
#define PREV_POSITION               0x00400000
#define PREV_SPEED                  0x00800000
#define PREV_ACCELERATION           0x01000000
#define PREV_NECK_DIRECTION			0x02000000
#define PREV_MASK                   0x03c00000

#define VISUAL_RANGE_NARROW			0x00000000
#define VISUAL_RANGE_NORMAL			0x00000001
#define VISUAL_RANGE_WIDE			0x00000002
#define VISUAL_RANGE_MASK   		0x00000003
#define VISUAL_QUALITY_LOW			0x00000000
#define VISUAL_QUALITY_HIGH			0x00000004
#define VISUAL_QUALITY_MASK 		0x00000004

#define PI							3.14159265359

#define UNKNOWN						-1
#define TEAM_PLAYER					0
#define ENEMY_PLAYER				1

#endif  // TYPES_H